/*
 *  main.c
 *
 *  Created by samel on 26/05/07.
 *  Copyright 2007 DoNotJava. All rights reserved.
 *
 */
/******************************************************************************\
*                                                                              *
*              Edit the make file and remove unwanted library !!!!!            *
*              If you move the project remember to make clean !!!!!            *
*                                                                              *
\******************************************************************************/

// include ours library //
#include "header.h"
#include <nds.h>
#include <dswifi9.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include "arm7.h"
#include "file.h"
#include "interrupt.h"
#include "io.h"
#include "network.h"
#include "timer.h"

#define RECV_SIZE 254
#define WORKING_PORT 21
#define MAX_CONNECTION 1

typedef void (*stub_type)(void); 

int main(void)
{
	
 // code goes here //
 
 char tosend='0';
 int sock=0;
 int nsock=0;
 int file=0;
 int old_size=0;
 struct sockaddr_in server;
 int accepts=sizeof(server);
 unsigned char buffer[RECV_SIZE];
 char file_name[RECV_SIZE];
 bzero(buffer,sizeof(buffer));
 
 _top_console_init();
 _bottom_console_init();
 _irq_init();
 _vbi_init();
 
 _set_color(UPPER,RED,BLACK);
 _print(UPPER,"Samel file uploader\n");
 _set_color(UPPER,VIOLET,BLACK);
 _print(UPPER,"[www.donotjava.altervista.org]\n");
 _set_color(UPPER,VIOLET,BLACK);
 _print(UPPER,"samelinux@gmail.com\n\n");
 _set_color(UPPER,GREY,BLACK);
 
 if(_fat_init()<0)
 {
  _print(UPPER,"Fat error, restart your DS\n");
  return -1;
 }
 if(_network_init()<0)
 {
  _print(UPPER,"Network error, restart your DS\n");
  return -1;
 }
  
 server.sin_family=AF_INET;
	server.sin_port=htons(WORKING_PORT);
 server.sin_addr.s_addr=INADDR_ANY;
 
 _print(UPPER,"Creating server socket ...\n");
 sock=socket(AF_INET,SOCK_STREAM,0);
 
 _print(UPPER,"Binding socket to port %d ...\n",WORKING_PORT);
 bind(sock,(struct sockaddr*)&server,sizeof(server));
 
 _print(UPPER,"Listening for connection ...\n");
 listen(sock,MAX_CONNECTION);
 
 while(1)
 {
  nsock=accept(sock,(struct sockaddr*)&server,&accepts);
  _print(UPPER,"Accepted a connection ...\n");
  
  recv(nsock,buffer,RECV_SIZE+1,0);
  memcpy(file_name,buffer+1,RECV_SIZE);
  _print(UPPER,"Creating file:");
  _set_color(UPPER,GREEN,BLACK);
  _print(UPPER," %s\n",file_name);
  _set_color(UPPER,GREY,BLACK);
  file=open(file_name,O_WRONLY|O_CREAT|O_TRUNC,0x777);
  old_size=buffer[0];
  
  _print(UPPER,"Reciveing file ...\n");
  while(old_size>0)
  {
   recv(nsock,buffer,RECV_SIZE+1,0);
   write(file,buffer+1,old_size);
   old_size=buffer[0];
   send(nsock,&tosend,1,0);
  }
  close(file);
  _print(UPPER,"Done receiving\n");
  _set_color(UPPER,WHITE,BLACK);
  _print(UPPER,"Now you can turn off your ds\n");
  _print(UPPER,"or send another file\n");
  _set_color(UPPER,GREY,BLACK);
  _print(UPPER,"Listening for connection ...\n");
 }
 
 // endless loop //

	while(1);
	
 // return //
	
 return 0;
}

// EOF //
