/*
 *  utility.h
 *
 *  Created by samel on 12/05/07.
 *  Copyright 2007 DoNotJava. All rights reserved.
 *
 */

//brief: debug trick
#ifdef DEBUG_ARM7_ENABLE
#define DEBUG_ARM7(S,A) {_set_color(S,ORANGE,BLACK);_print A;_set_color(S,GREY,BLACK);}
#else
#define DEBUG_ARM7(S,A)
#endif

/*
 brief: notification function to send fifo message to arm7
 */
void arm9_synctoarm7(void);

/*
 brief: interrupt handler to receive fifo messages from arm7
 */
void arm9_fifo(void);
