/*
 *  color.h
 *
 *  Created by samel on 12/05/07.
 *  Copyright 2007 DoNotJava. All rights reserved.
 *
 */

//brief: some usefull color definition
#define BLACK 0x0000
#define DGREY 0x1CE7
#define MGREY 0x39CE
#define GREY 0x56B5
#define LGREY 0x739C
#define WHITE 0xFFFF
#define DBLUE 0x1C00
#define MBLUE 0x3800
#define BLUE 0x5400
#define LBLUE 0x7000
#define DGREEN 0x00E0
#define MGREEN 0x01C0
#define GREEN 0x02A0
#define LGREEN 0x0380
#define DRED 0x0007
#define MRED 0x000E
#define RED 0x0015
#define LRED 0x001C
#define DVIOLET 0x1C07
#define MVIOLET 0x380E
#define VIOLET 0x5415
#define LVIOLET 0x701C
#define DYELLOW 0x01CE
#define MYELLOW 0x02B5
#define YELLOW 0x039C
#define LYELLOW 0x1F9C
#define DORANGE 0x00EE
#define MORANGE 0x01D5
#define ORANGE 0x01DC
#define LORANGE 0x02BC
#define DAZURE 0x1CE0
#define MAZURE 0x39C0
#define AZURE 0x56A0
#define LAZURE 0x7380
#define DBROWN 0x0C66
#define MBROWN 0x1D2C
#define BROWN 0x2DF2
#define LBROWN 0x3EB8

//brief: packs three values into a 15-bit color without trunkation
#define RGB(r,g,b) ((r)+(g<<5)+(b<<10))
//brief: packs three values into a 15-bit color with trunkation
#define RGBT(r,g,b) ((r & 0x1F)|((g & 0x1F)<<5)|((b & 0x1F)<<10))
