/*
 *  untitled.c
 *  
 *
 *  Created by samel on 26/05/07.
 *  Copyright 2007 Samel. All rights reserved.
 *
 */

#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>

#define RECV_SIZE 254
#define WORKING_PORT 21

int main(int argc, char** argv)
{
 int topen=0;
 int sock=0;
 int length=0;
 struct sockaddr_in server;
 char tmp[RECV_SIZE+1];
 char* file;
 
 if(argc<3)
 {
  printf("Use: %s IP FILE\n",argv[0]);
  return 0;
 }
 
 server.sin_family=AF_INET;
 server.sin_port=htons(WORKING_PORT);
 server.sin_addr.s_addr=inet_addr(argv[1]);

 printf("Opening file ... ");
 if((topen=open(argv[2],O_RDONLY,0x0777))<0)
 {
  printf("error opening file\n");
  return 0;
 }
 printf("done\n");
 
 printf("Getting length ... ");
 length=lseek(topen,0,SEEK_END);
 lseek(topen,0,SEEK_SET);
 printf("done\n");
 
 printf("Reading file ... ");
 file=malloc(length);
 read(topen,file,length);
 close(topen);
 printf("done\n");
 
 printf("Creating socket ... ");
 sock=socket(AF_INET,SOCK_STREAM,0);
 printf("done\n");
 
 printf("Connecting ... ");
 connect(sock,(struct sockaddr*)&server,sizeof(server));
 printf("done\n");
 
 printf("Sending file name ... ");
 bzero(tmp,sizeof(tmp));
 if(length>RECV_SIZE)
  tmp[0]=RECV_SIZE;
 else
  tmp[0]=length;
 memmove(tmp+1,argv[2],strlen(argv[2]));
 send(sock,tmp,RECV_SIZE+1,0);
 printf("done\n");
 
 printf("Sending file ");
 while(length>RECV_SIZE)
 {
  bzero(tmp,sizeof(tmp));
  if(length-RECV_SIZE>RECV_SIZE)
   tmp[0]=RECV_SIZE;
  else
   tmp[0]=length;
  memmove(tmp+1,file,RECV_SIZE);
  file+=RECV_SIZE;
  length-=RECV_SIZE;
  send(sock,tmp,RECV_SIZE+1,0);
  recv(sock,tmp,1,0);
  printf(".");
 }
 bzero(tmp,sizeof(tmp));
 tmp[0]=0;
 memmove(tmp+1,file,length);
 send(sock,tmp,RECV_SIZE+1,0);
 recv(sock,tmp,1,0);
 printf(" done\n");
 
 printf("Closeing connection ... ");
 shutdown(sock,2);
 printf("done\n");
 
 return 1;
}
